#include "../src/textdata.h" // Normally, "libharkio/textdata.h"

using namespace std;
//using namespace harkio;


void textdataTest() {

	string fname = "./micfile.txt";

	cout << "--- Reading MICARYLocationFile ---" << endl;
	try {

#if false
		// マイクフィファイルに限定しない読み込み
		{
			int type;
			harkio::TextData files;
			harkio::TextBase *file;
			file = files.readFile(fname);
			type = files.checkFileIdentifier(fname);

			// マイクファイルであるか？
			harkio::MICARYLocationFile* micfile;

			switch (type) {
			case harkio::TextData::TYPE::MICARYLocationFile:
				file = files.readFile(fname);
				micfile = ((harkio::MICARYLocationFile*) file);
				micfile->atLeastVersion(harkio::MICARYLocationFile::V1_0); // 最低バージョンのチェック
				break;
			default:
				cout << "Unknown FileType:" << fname << endl;
				break;
			}
			// マイクファイルの中身
			for (uint i = 0; i < micfile->mic_lists.size(); i++) {
				cout << i << ":"
						<< micfile->mic_lists[i].x
						<< "," << micfile->mic_lists[i].y
						<< "," << micfile->mic_lists[i].z
						<< endl;
			}
			delete micfile; // 開放
		}
#endif
		// マイクファイル限定の読み込み
		{
			harkio::MICARYLocationFile micfile;
			micfile.readFile(fname);
			micfile.atLeastVersion(harkio::MICARYLocationFile::V1_0);

			// マイクファイル中身
			for (uint i = 0; i < micfile.mic_lists.size(); i++) {
				cout << i << ":"
						<< micfile.mic_lists[i].x
						<< "," << micfile.mic_lists[i].y
						<< "," << micfile.mic_lists[i].z
						<< endl;
			}
		}

	} catch (harkio::Error& exp) {
		cout << "Error Message:" << exp.getMsg() << endl;
		throw;
	}
/*
	} catch (std::exception& exp) {
		cout << "Error Message:" << exp.what() << endl;
		throw;
	}
*/
}
